<template>
    <ion-page>
        <ion-header :translucent="true">
            <ion-toolbar>
                <ion-buttons slot="start">
                    <ion-menu-button color="primary"></ion-menu-button>
                </ion-buttons>
                <ion-title>Veřejné IPv4 adresy</ion-title>
            </ion-toolbar>
        </ion-header>

        <ion-content :fullscreen="true">
            <ion-progress-bar
                v-if="loading"
                type="indeterminate"
            ></ion-progress-bar>

            <p>Pro editaci 2x klikněte na pole.</p>

            <grid-wrapper :options="gridOptions" :rowData="rowData">
            </grid-wrapper>
        </ion-content>
    </ion-page>
</template>

<script setup lang="ts">
import {
    IonButtons,
    IonProgressBar,
    IonContent,
    IonHeader,
    IonMenuButton,
    IonPage,
    IonTitle,
    IonToolbar,
} from '@ionic/vue'
import { useMutation, useQuery } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { computed } from 'vue'
import { StaticIp, StaticIpEdge } from '@/gql/graphql'
import toast from '@/helpers/toast'
import GridButtonDelete from '@/component/Grid/GridButtonDelete.vue'
import GridButtonAdd from '@/component/Grid/GridButtonAdd.vue'
import {
    GridOptions,
    RowClickedEvent,
    CellEditRequestEvent,
} from 'ag-grid-community'
import GridWrapper from '@/component/Grid/GridWrapper.vue'

// Queries
const { mutate: updateStaticIp } = useMutation(gql`
    mutation updateStaticIp($id: ID!, $data: updateStaticIp!) {
        updateStaticIp(id: $id, staticIp: $data) {
            id
            device {
                id
                name
                ip
            }
            ip
            expiration
            createdAt
            updatedAt
        }
    }
`)

const { mutate: removeStaticIp } = useMutation(gql`
    mutation removeStaticIp($id: ID!) {
        removeStaticIp(id: $id)
    }
`)

const { mutate: createStaticIp } = useMutation(gql`
    mutation createStaticIp($data: createStaticIp!) {
        createStaticIp(staticIp: $data) {
            id
            device {
                id
                name
                ip
            }
            ip
            expiration
            createdAt
            updatedAt
        }
    }
`)

const { loading, result, refetch } = useQuery(
    gql`
        query StaticIpList {
            staticIpList(first: 10000) {
                edges {
                    node {
                        id
                        device {
                            id
                            name
                            ip
                        }
                        ip
                        expiration
                        createdAt
                        updatedAt
                    }
                }
            }
        }
    `,
    null,
    { fetchPolicy: 'network-only' }
)

// Grid

const rowData = computed(() =>
    result?.value?.staticIpList?.edges?.map((item: StaticIpEdge) => item.node)
)

const defaultAddData = {
    id: 'Nový',
    ip: '',
    expiration: null,
    createdAt: '-',
    updatedAt: '-',
}

const onCellEditRequest = (event: CellEditRequestEvent<StaticIp>) => {
    // Požadavek na přidání nového, aktualizovat data v gridu
    if (!Number(event.data?.id)) {
        event.node.setData({
            ...event.data, // Nechat původní data
            [event.colDef.field as string]: event.newValue,
        })
        return
    }

    updateStaticIp({
        id: event.data.id,
        data: {
            [event.colDef.field as string]: event.newValue,
        },
    }).then(() => {
        toast(
            'Pole ' + event.colDef.headerName + ' změněno z ' + event.oldValue,
            'success'
        )
    })
}

const onDeleteClick = (cellClicked: RowClickedEvent<StaticIp>) => {
    removeStaticIp({ id: cellClicked.data?.id }).then(() => {
        refetch()
        toast(cellClicked.data?.ip + ' smazáno', 'success')
    })
}

const onAddClick = (cellClicked: RowClickedEvent<StaticIp>) => {
    if (!cellClicked.data) {
        return
    }

    const data = (({ ip, expiration, device }) => ({ ip, expiration, device }))(
        cellClicked.data
    )

    createStaticIp({ data }).then(() => {
        refetch()
        cellClicked.node.setData(defaultAddData)
        toast(data.ip + ' přidáno', 'success')
    })
}

const gridOptions: GridOptions<StaticIp> = {
    onCellEditRequest: onCellEditRequest,
    pagination: true,
    pinnedTopRowData: [defaultAddData],
    columnDefs: [
        { field: 'id', headerName: 'id', width: 80, pinned: 'left' },
        {
            field: 'ip',
            headerName: 'ip',
            width: 150,
            cellClass: 'bold',
            editable: true,
        },
        {
            field: 'expiration',
            headerName: 'Expirace',
            type: 'date',
            editable: true,
            cellEditor: 'agDateCellEditor',
        },
        {
            field: 'device',
            headerName: 'Zařízení',
            type: 'device',
        },
        { field: 'createdAt', headerName: 'Založen', type: 'date' },
        { field: 'updatedAt', headerName: 'Poslední update', type: 'date' },
        {
            headerName: 'Akce',
            filter: false,
            sortable: false,
            cellRendererSelector: (params: any) => {
                if (!isNaN(params.data.id)) {
                    return {
                        component: GridButtonDelete,
                        params: { onClick: onDeleteClick },
                    }
                }
                return {
                    component: GridButtonAdd,
                    params: { onClick: onAddClick },
                }
            },
        },
    ],
}
</script>
<style>
.bold {
    font-weight: bold;
}
</style>
